// AlterEgo Classic
//================//
//===TO DO===
// combine checkPixels and drawPixels - to save CPU time :) Oh no need :)
//level names
//teleports count on each level
//lives gameover 
//passwords system
// sfx
// music

//;declare variables
.const screenStart = 1189
.const colorStart = 55461
//zero page variables
.var tempVar = 03 //temp variables for calculations
.var levelPointer = 04 //store a 16 bit levelPointer in $04 $05
.var screenPointer = 06 //store 16 bit pointer to screen in $06 $07
.var colorPointer = 08 //store 16 bit pointer to colors of screen in $08 $09
.var stackX = 10   //stack for X store
.var stackY = 11   //stack for Y stor
.var pixelsPointer = 12 // 12 13
.var pixelsFrame = 14 //14
.var animDelay = 15 //15
.var stack2X = 16   //second deep stack for X store
.var stack2Y = 17   //second deep stack for Y stor
.var starsPointer = 18 // 18 -19 pointer to stars table
.var heroFrame = 20 //
.var stackA = 21 //stack for a temporary
.var screenTablePointer = 22 // 22,23
.var phantomFrame = 24 //phantom anim frame
.var heroFirstFrame = 25 //first frame of current anim
.var heroLastFrame = 26 //hero last frame
.var currentAnimation = 27 //current hero animation 1-stand left 2-stand right 11-walk left 12-walk right
.var phantomKind = 28 // phantom kind 0-horizontal 1-vertical
.var teleportHeroX = 29//teleport hero dest
.var teleportHeroY = 30 //teleport hero dest
.var teleportPhantomX = 31//teleport hero dest
.var teleportPhantomY = 32 //teleport hero dest
.var heroState = 33 //hero states 0-normal 1-teleporting 2-dead 3-complete
.var fireButtonUp = 34 //trigger if fire button was up
.var enemiesPointer = 35 //35 -36 enemies table pointer
//enemies frames ticker
.var enemyRightFrame = 37 //for right moving enemies
.var enemyLeftFrame = 38 //for left moving enemies
.var enemyUpDownFrame = 39 //for up down enemies
.var spritePointer = 40 // 40 -41 pointer to sprite
.var enemyX = 42   //current enemy X
.var enemyY = 43   //current enemy Y
.var enemyMoveDir = 44 //current enemy moveDir
.var enemySpriteNum = 45 //current enemy sprite
.var enemyMoveCount = 46 //current enemy movecount
//crack bridge animation
.var crackBridgeFrame = 47 //frame of crack bridge
.var crackBridgeAddress = 48 //48 49 - screen address of cracking bridge
.var crackBridgeY = 50 //y dif to cbaddress
.var tmpX = 51 //temporary
.var tmpY = 52 //temporary
.var enemyDelay = 52 //delay enemy ticker

.var heroX_high = 53// high part for collision
.var enemyX_high = 54//high part for collision
.var collisionDX = 55 //dx for collision
.var collisionABSDX = 56 //for collisions
.var collisionDY = 57 //dy for collisions
.var collisionABSDY = 58 //for collisions
.var deadCount = 59 //count dead
.var collectCount = 60 //pixels count
.var globalCount = 61 //global count
.var restoreByte = 62 //byte to restore under tiles
.var tmpX2 = 63 //temporary
.var tmpY2 = 64 //temporary
.var charsetFrame = 65 //charset frame
.var charsetDelay = 66 //delay
.var playLevel = 67 //current level
.var textPointer = 68//pointer to text for draw

//====sounds====
.var currentDuration = 70//duration of current note
.var nPointer = 71 //pointer to note
.var sound = 72 //sound to play
.var notePointer = 73 //72 //73
.var phantomsCount = 75 //number of phantoms
.var lives = 76 //lives

.var SID = 54272

//joystick input
.var dx = 198
.var dy = 199

//positions
.var heroX = 200			//x cell coords
.var heroY = 201			//y cell coords
.var phantomX = 202			//x cell phantom coords
.var phantomY = 203			//y cell phantom coords
.var heroMoveCount = 204    //hero move count 
.var heroMoveDir = 205      //hero movedir
.var heroPreX = 206         //prev hero x pos
.var heroPreY = 207         //prev hero y pos

//asm variables
//global anim delay
.var vAnimDelay = 4 //12.5 hz draw every 4 frame
.var vCharsetDelay = 8 //charset anim delay
.var vStartLevel = 1 //start level
.var vMaxLives = 5 //max lives at start
.var vBaseSprites = 223


:BasicUpstart2(start)

.pc = $0810 "Main program"


start:
		

	jsr initSID
	jsr init //base init
	
			
	
	jsr init_screen //init screen
	
	jmp main_menu
	
	
restart:
	lda #05
	jsr playSound
	jsr hideSprites
	jsr updateStatusBar
	
	jsr wait_scanline
	
		
	jsr init_level //draw level on screen
			
	jsr init_hero //init hero
	
	
	lda #00
	sta enemyDelay
	
	
				
	game_loop:
	
	  jsr updateStatusBar
      jsr wait_scanline //wait for scanline
        
	  //animate and draw all animated tiles
	  jsr draw_anim_tiles 
	  //update animations    
	  jsr do_animation
	 
	  
	  //do enemies
	  	jsr do_enemies   
	  	  
	  //do hero  
	  jsr do_hero
	  
	  //visual scan line
	  //:SetBorderColor(7)
	  // nop nop nop nop nop nop
	  //:SetBorderColor(00)
	       
	  lda heroState
	  cmp #02//dead
	  beq level_dead
	  cmp #03
	  beq level_complete
	    	  
	  jmp game_loop
  
level_dead:
	lda #100
	sta globalCount
	jsr heroSetDeadAnimation
	jsr disablePhantom
	lda #00
	sta deadCount
	
	dec lives
	jsr updateStatusBar
	
	
dead_loop:
	dec globalCount
	beq restart_level
	
	jsr wait_scanline
	jsr draw_anim_tiles
	jsr do_animation
	jsr do_enemies
	jsr do_heroDeadMoving
	//inc $d027
	jmp dead_loop
	
level_complete:

	inc playLevel

	lda #125
	sta globalCount
	jsr heroSetCompleteAnimation
	jsr disablePhantom
	lda #00
	sta deadCount
	
complete_loop:
	dec globalCount
	beq restart_level
	
	jsr wait_scanline
	jsr draw_anim_tiles
	jsr do_animation
	jsr do_enemies
    jsr do_heroComplete
	jmp complete_loop
	  	  
restart_level:


jsr hideSprites

lda lives
bne next_life
jmp main_menu
next_life:

jmp restart
	
rts

//update text in status bar
updateStatusBar:


lda phantomsCount
clc
adc #48
sta t_status+32//lives +13

lda lives
clc
adc #48
sta t_status+13

jsr draw_statusbar

rts

//position all sprite y to invis
hideSprites:
lda #00
sta $d001
sta $d003
sta $d005
sta $d007
sta $d009
sta $d00b
sta $d00d
sta $d00f
rts

do_heroComplete:


//move hero sprite based on deltaY
ldx deadCount//get dead count

lda dead_deltaY,x//load delta


   //load color
   lda dead_colors,x
   sta $d029    //sprite 2 e.t.c it's an enemies
   sta $d02A
   sta $d02B
   sta $d02C
   sta $d02D
   sta $d02E
   

inc deadCount
lda deadCount
cmp #15
bne not_max_dead_count2
lda #14
sta deadCount

lda #00
//sta $d001
//sta $d003
sta $d005
sta $d007
sta $d009
sta $d00b
sta $d00d
sta $d00f

not_max_dead_count2:
   
rts

//dead animation moving
do_heroDeadMoving:

//move hero sprite based on deltaY
ldx deadCount//get dead count

lda dead_deltaY,x//load delta

clc
adc $d001 //load sprite 0 Y
sta $d001

//load color
lda dead_colors,x
sta $d027



inc deadCount
lda deadCount
cmp #15
bne not_max_dead_count
lda #14
sta deadCount
lda #0//hide
sta $d001//from screen
not_max_dead_count:

rts

//do enemies
do_enemies:

//enemies pointer points to first enemy
ldy #00 //reset y
ldx #06 //6 enemies
//jsr initEnemiesPointer //may remove ???

//delay enemy code
inc enemyDelay
lda enemyDelay
cmp #02
bne en_delay_not_max
lda #00
en_delay_not_max:
sta enemyDelay
/////////////////////

de_next_enemy:

//saveX
stx stackX
//enabled???
	lda (enemiesPointer),y
    cmp #00
	beq de_skip_this_enemy

	    //movedir
		iny
		lda (enemiesPointer),y
		sta enemyMoveDir
		//move count
		iny
		lda (enemiesPointer),y
		sta enemyMoveCount
		//sprite num
		iny
		lda (enemiesPointer),y
		sta enemySpriteNum
		//y
		iny
		lda (enemiesPointer),y
		sta enemyY
		//x
		iny
		lda (enemiesPointer),y
		sta enemyX
		//to the next sprite
		iny
		sty stackY//saveY
	
		//setup frames to enemies by movedir
		jsr enemyFrameSet
	
		//not update enemy id hero is teleporting dead or complette state	
		
		lda heroState
	  	cmp #01//teleporting
	    beq en_end_moving
	    cmp #03//complete level
	    beq en_end_moving
	  
		
		lda enemyDelay
		cmp #00
		bne en_end_moving
		
		//if move count = 0 then
		lda enemyMoveCount
		cmp #00
		bne en_moving
		jsr processOneEnemy//one step - change dirs and reset movecount
		jmp en_end_moving
		//else enemy is moving - just move sprite by movecount
		en_moving:
		//dec enemyMoveCount
		jsr enemyMoving
		
		//if we not teleporting then check collisions
		lda heroState
		cmp #01
		beq skip_collisions
		jsr check_collisions_with_hero
		skip_collisions:	
		
		
		en_end_moving:		
		
		
		
		//============
		ldy stackY//restoreY
						
		//save new x new y and new movidir and movecount:)
		dey //xx
		lda enemyX
		sta (enemiesPointer),y
		dey//y
		lda enemyY
		sta (enemiesPointer),y
		dey//sn
		dey//movecount
	    lda enemyMoveCount
	 	sta (enemiesPointer),y
		dey//movedir
		lda enemyMoveDir
		sta (enemiesPointer),y
			
		ldy stackY //restore again
		
		jmp de_end_current
		
de_skip_this_enemy:
iny iny iny iny iny iny
de_end_current:

ldx stackX //restoreX

dex
cpx #00
bne de_next_enemy

rts


//
enemyMoving:

dec enemyMoveCount

//move enemy sprite  based on move dir
lda enemyMoveDir
cmp #01
bne zzz_not_left
jsr moveEnemySpriteLeft
rts
zzz_not_left:
cmp #02
bne zzz_not_right
jsr moveEnemySpriteRight
rts
zzz_not_right:
cmp #04
bne zzz_not_up
jsr moveEnemySpriteUp
rts
zzz_not_up:
cmp #03
bne zzz_not_down
jsr moveEnemySpriteDown
rts
zzz_not_down:


rts

//moving sprites

moveEnemySpriteUp:

lda enemySpriteNum //get sprite num
jsr getSpriteAddressY//get address
//get x addr
ldy #00
lda (spritePointer),y
sec
sbc #01
sta (spritePointer),y
rts

moveEnemySpriteDown:

lda enemySpriteNum //get sprite num
jsr getSpriteAddressY//get address
//get x addr
ldy #00
lda (spritePointer),y
clc
adc #01
sta (spritePointer),y
rts

moveEnemySpriteRight:

lda enemySpriteNum //get sprite num
jsr getSpriteAddressX//get address
//get x addr
ldy #00
lda (spritePointer),y
clc //clear carry flag
adc #01 //add 1
sta (spritePointer),y
bcc xxx_not_more_256
//more than 256 - set bit at $d010
lda enemySpriteNum
jsr getSpriteMask
ora $d010//set
sta $d010//bit

xxx_not_more_256:

rts

moveEnemySpriteLeft:

lda enemySpriteNum //get sprite num
jsr getSpriteAddressX//get address
//get x addr
ldy #00
lda (spritePointer),y
sec //set carry flag
sbc #01 //sub 1
sta (spritePointer),y
bcs xxx_not_less_256
//less than 256 - reset bit
lda enemySpriteNum
jsr getSpriteMask
//lda $d010
eor #$ff
and $d010//set
sta $d010//bit
xxx_not_less_256:
rts


enemyFrameSet:

lda enemySpriteNum
jsr getSpriteFrame//get adress of sprite frame

//setup frame based on movedir
ldy #00
//process enemies based on movedir
lda enemyMoveDir
cmp #01
beq em_left_movedir
cmp #02
beq em_right_movedir
//here is up down dir
//setup sprite frame
lda enemyUpDownFrame
sta (spritePointer),y
jmp em_end_detect
//====================
em_left_movedir:
//setup sprite frame
lda enemyLeftFrame
sta (spritePointer),y
jmp em_end_detect
em_right_movedir:
//setup sprite frame
lda enemyRightFrame
sta (spritePointer),y
em_end_detect:

rts

//process one enemy
//all in parameter is memory vars
//enemyX , enemyY - cell coords
//enemySpriteNum - associated spriteNumber
//enemyMoveDir - move direction
//enemyMoveCount - current moveCount

processOneEnemy:

//position sprite by cell coords
ldx enemyX
lda enemySpriteNum
jsr getSpriteMask
jsr calculateX
//now in X - real coord 
//save it to x address of ass sprite
lda enemySpriteNum
jsr getSpriteAddressX
//save our x coord to x address
	ldy #00
	txa
	sta (spritePointer),y
//ok Y
lda enemySpriteNum
jsr getSpriteAddressY
//save y coord to y address
	ldy enemyY
	jsr calculateY
	tya
	ldy #00
	sta (spritePointer),y
	

//frame
//lda enemySpriteNum
//jsr getSpriteFrame//get adress of sprite frame

ldy #00
//process enemies based on movedir

lda enemyMoveDir
cmp #01
beq pe_left_movedir
cmp #02
beq pe_right_movedir
cmp #04
beq pe_up_movedir
//moving down
jsr moveEnemyDown
rts
//====================
pe_up_movedir:
jsr moveEnemyUp
rts
pe_left_movedir:
//moving
jsr moveEnemyLeft

rts
pe_right_movedir:
//moving
jsr moveEnemyRight


rts



moveEnemyUp:

ldx enemyX
ldy enemyY
dey //up wall
jsr getCollisionByteFromCell
//01 - solid
cmp #01
bne meu_not_wall
//change dir and return
lda #03//down
sta enemyMoveDir
rts
meu_not_wall:
//05 - bridg
cmp #05
bne meu_not_bridge
//change dir and return
lda #03//down
sta enemyMoveDir
rts
meu_not_bridge:


dec enemyY

lda #08
sta enemyMoveCount

rts

moveEnemyDown:

ldx enemyX
ldy enemyY
iny //down wall
jsr getCollisionByteFromCell
//01 - solid
cmp #01
beq med_cant
cmp #03 //water
beq med_cant
cmp #05
bne med_not_wall
med_cant:
//change dir and return
lda #04//up
sta enemyMoveDir
rts
med_not_wall:

inc enemyY

lda #08
sta enemyMoveCount

rts

//move horizontal enemies
moveEnemyLeft:

ldx enemyX
ldy enemyY
dex //left wall
jsr getCollisionByteFromCell
//01 - solid
cmp #01
bne mer_not_wall
//change dir and return
lda #02//right
sta enemyMoveDir
rts
mer_not_wall:
//not wall
//now what under skull??
ldx enemyX
ldy enemyY
dex //left
iny //under skull
jsr getCollisionByteFromCell
//01 - solid 02-ladder
cmp #01
beq mer_canMove
cmp #02
beq mer_canMove
cmp #05
beq mer_canMove
//change dir and return
lda #02//right
sta enemyMoveDir
rts

mer_canMove:
dec enemyX

lda #08
sta enemyMoveCount

rts

moveEnemyRight:

ldx enemyX
ldy enemyY
inx //right wall
jsr getCollisionByteFromCell
//01 - solid
cmp #01
bne mel_not_wall
//change dir and return
lda #01//left
sta enemyMoveDir
rts
mel_not_wall:
//not wall
//now what under skull??
ldx enemyX
ldy enemyY
inx //right
iny //under skull
jsr getCollisionByteFromCell
//01 - solid 02-ladder
cmp #01
beq mel_canMove
cmp #02
beq mel_canMove
cmp #05
beq mel_canMove
//change dir and return
lda #01//left
sta enemyMoveDir
rts

mel_canMove:
inc enemyX

lda #08
sta enemyMoveCount

rts

getCollisionByteFromCell:
jsr getByteFromCell
//load collision by byte
tax//to x
lda tiles_collisions,x //load to a color and collision date of tile
rts


//disable phantom
disablePhantom:
//lda $d01e //Read hardware sprite/sprite collision
lda #02 //sprite 1
eor #$ff
and $d015
sta $d015
rts

//enablePhantom
enablePhantom:
//lda $d01e //Read hardware sprite/sprite collision
lda #02 //sprite 1
ora $d015
sta $d015


rts




//check if current enemy hit hero
check_collisions_with_hero:

//if hero is dead - skip
lda heroState
cmp #02
bne cc_contz
rts
cc_contz:

//reset high parts
 lda #00
 sta heroX_high
 sta enemyX_high
 
 //compare 256 for hero
 lda #01 //first sprite
 bit $d010
 beq pp_less_256//if reset - less than 256
 lda #01//set high byte
 sta heroX_high//save
 pp_less_256:
 
 //compare 256 for enemy
 lda enemySpriteNum
 jsr getSpriteMask
 bit $d010
 beq zz_less_256
 lda #01
 sta enemyX_high
 zz_less_256:
 
//==================upper part it's OK===================

 //rts
 
 //ok now collision
        
   lda enemySpriteNum
   jsr getSpriteAddressX
   ldy #00
   lda (spritePointer),y
   
   sec 			//set carry flag
   sbc $d000  //subtrack x coords
         
   sta     collisionDX //save diff
   
   lda     enemyX_high
   sbc     heroX_high
   bcc     dxneg
   
   bne     skip                   // dx in [0,23] ?
   lda     collisionDX
   cmp     #06
   bcc     xok
   bcs     skip
        
   dxneg:
   
   		cmp     #$ff                    // dx in [-23,-1] ?
        bne     skip
        lda     collisionDX
        cmp     #-06
        bcc     skip
        eor     #$ff
        adc     #0
    
   xok:
   	   	
        //sta     collisionABSDX
      // 	inc $d020
   		
        sec                             // repeat with dy, range [-20,20]
        			                   // a bit easier, as we DON'T have high byte
        lda enemySpriteNum
   		jsr getSpriteAddressY
   		ldy #00
   		lda (spritePointer),y
   		
   		sbc $d001
                  
        sta     collisionDY
        bcc     dyneg
        cmp     #12
        bcc     yok
        bcs     skip
        
        dyneg:
   
   		cmp     #-12
        bcc     skip
        eor     #$ff
        adc     #0
   yok:
   		//inc $d020
   		//sta     collisionABSDY 
   		//dead hero
   		lda #02
   		sta heroState
   		lda #03
   		jsr playSound
   skip:
  
   
rts

//do hero
do_hero:


//check hero states
lda heroState
cmp #01//is teleporting
bne dh_not_teleporting
jsr teleportStep
jmp end_controls_main
dh_not_teleporting:

lda heroMoveCount //if move count is zero then check for moving
cmp #00
bne continue_moving
	//so we stopped - check pixels to collect
	jsr checkPixels
	//check for teleport button if pressed then teleport even if we falling
	jsr read_joy
	
	bcs ct_not_tel
	//
	lda fireButtonUp
	cmp #00//was up
	bne ct_not_continue
	inc fireButtonUp//button state not up
	jsr teleporting
	jmp end_controls_main
	
	ct_not_tel:
	lda #00 //reset - button is up
	sta fireButtonUp
	ct_not_continue:
	
	//before controls check check for fall down :)
	jsr checkFall
	//skip if we fall down
	lda heroMoveCount //if move count is zero then check controls - we not falling
	cmp #00
	bne continue_moving
	jsr controls
	jmp end_controls_main
continue_moving:
//we are moving
jsr moveHero
end_controls_main:

//calculate phantom position, move sprite
jsr do_phantom

rts


//teleporting loop
//move hero and phantom before we reach destinations
//we need teleport count and teleport direction :)
teleporting:

//check if we can teleport - what under phantom

ldx phantomX
ldy phantomY
jsr getByteFromCell
tay
lda tiles_collisions,y
cmp #01
bne not_solid_teleport_legs
rts
not_solid_teleport_legs:
//now under head
ldx phantomX
ldy phantomY
dey
jsr getByteFromCell
tay
lda tiles_collisions,y
cmp #01
bne not_solid_teleport_head
rts
not_solid_teleport_head:


//check if phantoms count is ready
lda phantomsCount
bne not_zero_phantoms
rts
not_zero_phantoms:
dec phantomsCount


//play teleport sound
lda #04
jsr playSound

//setup destination
lda heroX
sta teleportPhantomX
lda heroY
sta teleportPhantomY
lda phantomX
sta teleportHeroX
lda phantomY
sta teleportHeroY

//setup teleporting flag in hero state
lda #01
sta heroState
	
rts

//one teleport step
teleportStep:
	///check if hero reach destination
	lda heroX
	cmp teleportHeroX
	bne ts_not_reach
	lda heroY
	cmp teleportHeroY
	bne ts_not_reach
	//we reach a final - reset hero state
	lda #00
	sta heroState
	rts
	ts_not_reach:
	
	
	//check if same X not change it
	lda teleportHeroX
	cmp teleportPhantomX
	beq ts_end_x
		
	//x dif
	lda heroX
	cmp teleportHeroX
	bpl ts_hero_bigger
	
	inc heroX
	jmp ts_end_x
	ts_hero_bigger:
	dec heroX
	ts_end_x:
	
	//check if same y not change it
	lda teleportHeroY
	cmp teleportPhantomY
	beq ts_end_y
	
	//y dif
	lda heroY
	cmp teleportHeroY
	bpl ts_hero_bigger_y
	
	inc heroY
	jmp ts_end_y
	ts_hero_bigger_y:
	dec heroY
	ts_end_y:
		
	jsr snapHero

rts

//do phantom calculations
do_phantom:

	

  lda phantomKind
  cmp #00
  bne dp_vertical_ph
  jsr horPhantom//x phantom
  jmp dp_end
dp_vertical_ph:
  jsr verPhantom//x phantom
dp_end:


  //set up phantom sprite
  ldx phantomX
  lda #02 //second bit = sprite 1
  jsr calculateX
  stx $d002    // set x coordinate
                   
  ldy phantomY //load y
  jsr calculateY
  sta $d003    // set y coordinate

rts

//====vertical phantom calculates ====
verPhantom:

ldx heroY
cpx #11
bmi pv_less_20
//so heroY >20
lda heroY//center
clc
sbc #12//sub 20
sta phantomY //save dif
lda #12//center
clc
sbc phantomY //add dif
sta phantomY //save
jmp pv_end_calc
pv_less_20:
//so hero x <20
lda #12 //center
clc
sbc heroY//minus x pos
sta phantomY//save dif to phX
lda #13//center
clc
adc phantomY//add dif
sta phantomY//save
pv_end_calc:
lda heroX
sta phantomX

rts

//====horizontal phantom calculates===
horPhantom:

ldx heroX

//fix bug in mirrored
//if hero 1 - then make phantom = 29+5 = 34
cpx #01+5
bne ph_no_need_fix
lda #33
sta phantomX
jmp ph_end_calc
ph_no_need_fix:

cpx #19
bmi ph_less_20
//so heroX >20
lda heroX//center
clc
sbc #20//sub 20
sta phantomX //save dif
lda #20//center
clc
sbc phantomX //add dif
sta phantomX //save
jmp ph_end_calc
ph_less_20:
//so hero x <20
lda #21 //center
clc
sbc heroX//minus x pos
sta phantomX//save dif to phX
lda #20//center
clc
adc phantomX//add dif
sta phantomX//save
ph_end_calc:
lda heroY
sta phantomY

rts

//check pixels to collect
checkPixels:
		
  	ldy #00 //reset y 
    	
  	ldx #16 //pixels count
	cp_next_pixel:
	lda #00
	sta tempVar //reset temp var
	//get state
	lda (pixelsPointer),y
	sty stackY
	cmp #00 //disabled
	beq cp_skip//skip it
		//ok check it
		//get kind
		iny //kind temporary
		lda (pixelsPointer),y
		iny//low byte
		iny//hi byte
			
		//is it normal pixel
		cmp #00
		bne cp_its_phantom
		//it's regular pixel
		lda heroX
		sta cp_compareX+1
		sta cp_clearX+1
		lda heroY
		sta cp_compareY+1
		sta cp_clearY+1
		jmp cp_continue
cp_its_phantom:
		//it's phantom pixel
		lda phantomX
		sta cp_compareX+1
		sta cp_clearX+1
		lda phantomY
		sta cp_compareY+1
		sta cp_clearY+1
cp_continue:
	
		iny//y
		lda (pixelsPointer),y
cp_compareY:		cmp #heroY //self modify
		bne cp_y_not_match
		inc tempVar //temp var+1
		cp_y_not_match:
		iny//x
		lda (pixelsPointer),y
cp_compareX:	cmp #heroX //self modify
		bne cp_x_not_match
		inc tempVar //tempVar+1
		cp_x_not_match:
		//so if tempVar = 2 then collect it
		lda tempVar
		cmp #02
		bne cp_not_collect
		//collect pixel
		//save current y
		sty stack2Y
		//restore pre y
		ldy stackY
		lda #00//disable pixel
		sta (pixelsPointer),y
		//set fram
		//restore y
		ldy stack2Y
		//clear on screen
		//save all
		sty stackY
		stx stackX
		
cp_clearX:		ldx #heroX //self modify
cp_clearY:		ldy #heroY //self modify
		jsr restore_under
		
		//restore all
		ldy stackY
		ldx stackX
	
		jsr collect_pixel
		
		cp_not_collect:
		
		iny//next pixel start
	    jmp cp_skip2
	//skip this pixel    
	cp_skip:
	iny iny	iny	iny iny iny
	//end skips
	cp_skip2:
	//to the next
	dex
	cpx #00
	bne cp_next_pixel

rts

restore_under:

		
		
		stx tmpX2
		sty tmpY2
												
    	lda restoreByte
		jsr putByteToCell
		
		ldx restoreByte
		lda tiles_colors,x
		ldx tmpX2
		ldy tmpY2
		jsr putColorToCell
rts

//collect pixel
collect_pixel:
		lda #02
		dec collectCount
		bne not_finished
		lda #03
		sta heroState
		lda #01
		not_finished:
		sty tmpY2
		jsr playSound
		ldy tmpY2
		
rts

//check hero for fall down
//we need FIX for fall to ladder fx 
checkFall:

	//fall for screen
	lda heroY
	cmp #18
	bmi not_fall_from_level
		lda #02
		sta heroState
		lda #03
   		jsr playSound
	rts
	not_fall_from_level:
	
	//JUMP FROM LADDER FIX
	//if ladder on head - not fall
	ldx heroX
	ldy heroY
	dey //under head
	jsr getByteFromCell
	//load collision by byte
	tax//to x
	lda tiles_collisions,x //load to a color and collision date of tile
	
	//02 - ladder
	cmp #02
	bne cf_not_ladder
	rts
	cf_not_ladder:
	
	//get byte from screen
    ldx heroX
	ldy heroY
	iny //under legs
	jsr getByteFromCell
	//load collision by byte
	tax//to x
	lda tiles_collisions,x //load to a color and collision date of tile
	
	
	// 01 - land is solid
	cmp #01
	bne cf_not_solid
	//stand on
	lda #00
	sta heroMoveDir
	sta heroMoveCount
	rts
	cf_not_solid:
			
	//check_water
	cmp #03
	bne not_water_dead
	lda #02//dad
	sta heroState
	   	lda #03
   		jsr playSound
   		
	not_water_dead:
	
	//land on bridge
	//05 - bridge
	cmp #05
	bne cf_not_bridge
	//stand on
	lda #00
	sta heroMoveDir
	sta heroMoveCount
	rts	
	cf_not_bridge:
	
	//LADDERS FIX - FALL ON LADDER
	//if ladder on legs (not under) - stop falling
	//legs
	ldx heroX
	ldy heroY
	jsr getByteFromCell
	//load collision by byte
	tax//to x
	lda tiles_collisions,x //load to a color and collision date of tile
	
		
	//only 02 - ladder
	cmp #02
	bne cf_fall_0
	rts
	cf_fall_0:
			
	lda #08
	sta heroMoveCount
	lda #03
	sta heroMoveDir
	jsr getNewPosition
	jsr heroSetStopAnimation
			
	
rts

//read controls
//and check for moving
controls:

jsr read_joy

//if carry clear - fire not pressed
//bcs not_fire_pressed
//lda fireButtonUp
//cmp #00//was up
//bne end_controls
//inc fireButtonUp//button state not up
//jsr teleporting
//jmp end_controls
//not_fire_pressed: 

//	lda #00 //reset
//	sta fireButtonUp//fire button state
	
	lda dx
	cmp #-1
	bne not_left_pressed
	lda #01
	sta heroMoveDir
	jsr checkForMovingX
	jmp end_controls
not_left_pressed:
	cmp #01
	bne not_right_pressed
	lda #02
	sta heroMoveDir
	jsr checkForMovingX
	jmp end_controls
not_right_pressed:

	lda dy
	cmp #1
	bne not_down_pressed
	//down
	lda #03
	sta heroMoveDir
	jsr checkForMovingDown
	jmp end_controls
not_down_pressed:
	cmp #-1
	bne end_controls
	//up 
	lda #04
	sta heroMoveDir
	jsr checkForMovingUp
end_controls:
	//if hero move count = 0 then set stand anim
	lda heroMoveCount
	cmp #00
	beq controls_stop
	rts
	controls_stop:
	jsr heroSetStopAnimation


rts

//check for moving
//read byte from hero pos
//and if we can move then movecount = 8
checkForMovingX:
	//set move count to 8
	lda #08
	sta heroMoveCount
	
	//move hero to new position
	jsr saveHeroPosition
	jsr getNewPosition
	
	//get byte from screen
    ldx heroX
	ldy heroY
	jsr getByteFromCell
	//load collision by byte
	tax//to x
	lda tiles_collisions,x //load to a color and collision date of tile
	//only 01 - land is solid
	cmp #01
	bne cfm_not_solid
	jsr restoreHeroPosition
	rts
	cfm_not_solid:
	
	//check on head
	//get byte from screen
    ldx heroX
	ldy heroY
	dey //head
	jsr getByteFromCell
	//load collision by byte
	tax//to x
	lda tiles_collisions,x //load to a color and collision date of tile
	//only 01 - land is solid
	cmp #01
	bne cfm_not_solid_2
	jsr restoreHeroPosition
	rts
	cfm_not_solid_2:
	
	//we can move horiz
	//check if we was on bridge - then destroy bridge
	ldx heroPreX
	ldy heroPreY
	iny //under legs
	jsr getByteFromCell
	tax
	lda tiles_collisions,x//get collision type
	cmp #05
	beq cfm_bridge
	rts
	cfm_bridge:
	ldx heroPreX
	ldy heroPreY
	iny
	//lda #0
	//jsr putByteToCell
	
	jsr restore_under
	//setup crack bridge
	sty crackBridgeY
	lda #39
	sta crackBridgeFrame
	lda screenPointer
	sta crackBridgeAddress
	lda screenPointer+1
	sta crackBridgeAddress+1
	
rts

checkForMovingUp:
	
	//we can move up if there is a ladder on head and not solid above head
	//get byte from screen
    ldx heroX
	ldy heroY
	dey //head
	jsr getByteFromCell
	//load collision by byte
	tax//to x
	lda tiles_collisions,x //load to a color and collision date of tile
		
	//ladder on head
	//02 - it's a ladder
	cmp #02
	beq head_ladder
	//not ladder
	rts
	head_ladder:
	//above head
	ldx heroX
	ldy heroY
	dey
	dey
	jsr getByteFromCell
	//load collisions by byte
	tax
	lda tiles_collisions,x
	//ladder above head
	cmp #01
	bne above_free //if not solid
	//solid - stop
	rts
	above_free:
	//we can move
	lda #08
	sta heroMoveCount
	jsr getNewPosition
rts

checkForMovingDown:
	//we can move down if there is a ladder on legs(or HEAD - JUMP FROM LADDER) and not solid under legs
	//get byte from screen
	//legs
    ldx heroX
	ldy heroY
	jsr getByteFromCell
	//load collision by byte
	tax//to x
	lda tiles_collisions,x //load to a color and collision date of tile	
	//ladder on legs
	//02 - it's a ladder
	cmp #02
	beq legs_ladder2
	//not ladder
	
	//maybe ladder on head
	ldx heroX
	ldy heroY
	dey //head
	jsr getByteFromCell
	//load collision by byte
	tax//to x
	lda tiles_collisions,x //load to a color and collision date of tile	
	//02 - it's a ladder
	cmp #02
	beq legs_ladder2
	rts
	
	legs_ladder2:
	
	ldx heroX//leg
	ldy heroY
	iny //under leg
	jsr getByteFromCell
	//load collisions by byte
	tax
	lda tiles_collisions,x
	//solid on leg
	cmp #01
	bne not_solid_under //if not solid we can move
	//not ladder
	rts
	not_solid_under:
	cmp #05
	bne not_bridge_under //bridge
	rts
	not_bridge_under:
	//we can move
	lda #08
	sta heroMoveCount
	jsr getNewPosition

rts

//save hero pos as pre pos
saveHeroPosition:
lda heroX
sta heroPreX
lda heroY
sta heroPreY
rts

//restore hero position from pre pos
restoreHeroPosition:
lda heroPreX
sta heroX
lda heroPreY
sta heroY
//reset move count
lda #00
sta heroMoveCount
rts

//get new position based on move dir
getNewPosition:
lda heroMoveDir

cmp #01
bne gnp_not_1
dec heroX
jsr heroSetWalkLeftAnimation
rts
gnp_not_1:
cmp #02
bne gnp_not_2
inc heroX
jsr heroSetWalkRightAnimation
rts
gnp_not_2:
cmp #03
bne gnp_not_3
inc heroY
jsr heroSetLadderAnimation
rts
gnp_not_3:
cmp #04
bne gnp_not_4
dec heroY
jsr heroSetLadderAnimation
rts
gnp_not_4:

rts

//get new position based on a - dir
//a - direction
//x-xpos
//y-ypos

getNewPositionXYA:
cmp #01
bne _gnp_not_1
dex
rts
_gnp_not_1:
cmp #02
bne _gnp_not_2
inx
rts
_gnp_not_2:
cmp #03
bne _gnp_not_3
iny
rts
_gnp_not_3:
cmp #04
bne _gnp_not_4
dey
rts
_gnp_not_4:

rts

//set hero animations
hero_process_animation:

		//if first frame = last frame then animation is stoppe
		lda heroFirstFrame
		cmp heroLastFrame
		beq skip_hero_animation

		//hero animation update
		inc heroFrame
		lda heroFrame
		cmp heroLastFrame
		//bmi not_hero_last_frame
		bne not_hero_last_frame
		lda heroFirstFrame
		sta heroFrame
		not_hero_last_frame:
		sta $07f8
		
		skip_hero_animation:
rts


heroSetCompleteAnimation:
	lda #28+vBaseSprites
	sta $07f8    // set pointer: sprite data
	sta heroFrame
	sta heroFirstFrame
	lda #32+vBaseSprites
	sta heroLastFrame
	lda #00
	sta currentAnimation
rts

heroSetStopAnimation:

lda heroFrame
sta heroFirstFrame
sta heroLastFrame
sta $07f8

lda #00
sta currentAnimation

rts

heroSetSitAnimation:

lda #32+vBaseSprites
sta heroFirstFrame
sta heroFrame
sta $07f8
lda #33+vBaseSprites
sta heroLastFrame


lda #00
sta currentAnimation

rts

heroSetDeadAnimation:

lda #15+vBaseSprites
sta heroFirstFrame
sta heroLastFrame
sta $07f8

lda #00
sta currentAnimation

rts

heroSetStandRightAnimation:
	//check if not this animation allready
	lda currentAnimation
	cmp #02
	bne set_anim0
	rts
	set_anim0:
	lda #00+vBaseSprites
	sta $07f8    // set pointer: sprite data
	sta heroFrame
	sta heroFirstFrame
	sta heroLastFrame
	lda #02
	sta currentAnimation
	
rts

heroSetWalkRightAnimation:
//check if not this animation allready
//check if not this animation allready
	lda currentAnimation
	cmp #12
	bne set_anim1
	rts
	set_anim1:
	lda #00+vBaseSprites
	sta $07f8    // set pointer: sprite data
	sta heroFrame
	sta heroFirstFrame
	lda #04+vBaseSprites
	sta heroLastFrame
	lda #12
	sta currentAnimation
rts

heroSetStandLeftAnimation:
//check if not this animation allready
	lda currentAnimation
	cmp #1
	bne set_anim2
	rts
	set_anim2:
	lda #04+vBaseSprites
	sta $07f8    // set pointer: sprite data
	sta heroFrame
	sta heroFirstFrame
	sta heroLastFrame
	
	
	lda #1
	sta currentAnimation
rts

heroSetWalkLeftAnimation:
//check if not this animation allready
	lda currentAnimation
	cmp #2
	bne set_anim3
	rts
	set_anim3:
	
	lda #04+vBaseSprites
	sta $07f8    // set pointer: sprite data
	sta heroFrame
	sta heroFirstFrame
	lda #08+vBaseSprites
	sta heroLastFrame
	lda #2
	sta currentAnimation
rts

heroSetLadderAnimation:
//check if not this animation allready
	lda currentAnimation
	cmp #3
	bne set_anim4
	rts
	set_anim4:
	
	lda #08+vBaseSprites
	sta $07f8    // set pointer: sprite data
	sta heroFrame
	sta heroFirstFrame
	lda #12+vBaseSprites
	sta heroLastFrame
	lda #3
	sta currentAnimation
rts

//draw animated tiles
//we can animate water by switching charsets, if massive
draw_anim_tiles:
	
	//darw jumping pixels
	jsr draw_pixels
	//draw stars
	jsr draw_stars
rts

//animations update
do_animation:

	

	//update animating
	      	   
	   //no delay animation (50hz)
		jsr process_charset_animations
	   jsr process_crack_bridge_animation
	   
	   //set phantom frame
	   inc phantomFrame
	   lda phantomFrame
	   cmp #15+vBaseSprites
	   bne ph_not_final_frame
	   lda #12+vBaseSprites
	   sta phantomFrame
	   ph_not_final_frame:
	   sta $07f9    // set pointer: sprite data 1
	   //inc $d028	   
	   
	   		
       //check delay count(12.5 hz)
	   dec animDelay
	   bne do_anim_skip //not
		
		lda #vAnimDelay //reset counter
		sta animDelay  //save it
				
		
		jsr process_enemies_animations
		jsr hero_process_animation
		
		//next frame for all pixels
		inc pixelsFrame//inc current frame
		lda pixelsFrame	
	    cmp #21			//is it max ?
		bne do_anim_skip_pixels
		lda #17			//reset to first frame
		sta pixelsFrame		
		
		
do_anim_skip_pixels:


    //next frame for every star
	
	ldy #00 //reset y
	ldx #08 //stars count
	
	do_anim_next_star:
	
	//get state
	lda (starsPointer),y
	cmp #00 //disabled
	beq do_anim_skip_star//skip it
	
	iny
	lda (starsPointer),y//get frame
	clc
	adc #01//next frame
	cmp #32
	bne do_as_not_last_frame
	lda #21
do_as_not_last_frame:
	sta (starsPointer),y//save new one		
	dey
	//skip this star
do_anim_skip_star:
	iny iny	iny	iny
    //end skips
	ds_anim_skip_star2:
	//to the next
	dex
	cpx #00
	bne do_anim_next_star



do_anim_skip:
rts

//process charset animations
process_charset_animations:

dec charsetDelay
beq do_frame
rts

do_frame:

lda #vCharsetDelay
sta charsetDelay

lda charsetFrame
sta $d018

cmp #26
beq switch_to_24
lda #26
sta charsetFrame
rts
switch_to_24:
lda #24
sta charsetFrame
  
rts

//prcoess crack bridge
process_crack_bridge_animation:

	   //crack bridge animation
	   lda crackBridgeFrame
	   cmp restoreByte //is disabled //00
	   beq skip_crack
	   cmp #43
	   bne not_end_crack
	   //crack end
	   lda restoreByte				//00
	   sta crackBridgeFrame
	   //write to screen
	   ldy crackBridgeY
	   sta (crackBridgeAddress),y
	   
	   jmp skip_crack
	   not_end_crack:
	   inc crackBridgeFrame
	   //save it to adress
	   lda crackBridgeFrame
	   ldy crackBridgeY
	   sta (crackBridgeAddress),y
	   skip_crack:
	   
rts

//enemys animations
process_enemies_animations:

//.var enemyRightFrame = 37 //for right moving enemies
//.var enemyLeftFrame = 38 //for left moving enemies
//.var enemyUpDownFrame = 39 //for up down enemies

//right frames
inc enemyRightFrame
lda enemyRightFrame
cmp #20+vBaseSprites
bne pea_not_right_last_frame


lda #16+vBaseSprites
sta enemyRightFrame
pea_not_right_last_frame:
//left frames
inc enemyLeftFrame
lda enemyLeftFrame
cmp #24+vBaseSprites
bne pea_not_left_last_frame
lda #20+vBaseSprites
sta enemyLeftFrame
pea_not_left_last_frame:
//updown frames
inc enemyUpDownFrame
lda enemyUpDownFrame
cmp #28+vBaseSprites
bne pea_not_ud_last_frame
lda #24+vBaseSprites
sta enemyUpDownFrame
pea_not_ud_last_frame:

rts


//draw stars
draw_stars:

	ldy #00 //reset y
	ldx #08 //stars count
	
	ds_next_star:
	
	//get state
	lda (starsPointer),y
	
		cmp #00
		beq ds_skip1
		
		iny //to frame
		lda (starsPointer),y//frame
		pha//save frame
		
		iny//low byte
		lda (starsPointer),y
		sta screenPointer//save to screen pointer
		iny//hi byte
		lda (starsPointer),y
		sta screenPointer+1//save to screen pointer
		//now screen points to need a draw place
		//save Y
		sty stackY
		pla //restore frame
		ldy #00
		sta (screenPointer),y//screen pointer
		//restoreY
		ldy stackY
		iny//to then next star
		jmp ds_skip2
	ds_skip1:
	iny iny iny iny
	ds_skip2:
	//to the next
	dex
	cpx #00
	bne ds_next_star

rts

//draw jumping pixels
draw_pixels:

	ldy #00 //reset y
	ldx #16 //pixels count
	
	dp_next_pixel:
	
	//get state
	lda (pixelsPointer),y
	cmp #00 //disabled
	beq dp_skip//skip it
		//ok draw it
		iny //skip kind temporary
	
		iny//low byte
		lda (pixelsPointer),y
		sta screenPointer//save to screen pointer
		iny//hi byte
		lda (pixelsPointer),y
		sta screenPointer+1//save to screen pointer
		//now screen points to need a draw place
		//save Y
		sty stackY
		//draw it	
		ldy #00

		lda pixelsFrame
		
		sta (screenPointer),y	
		//restoreY
		ldy stackY
		iny//to then next pixel
		iny
		iny
	    jmp dp_skip2
	//skip this pixel    
	dp_skip:
	iny iny	iny	iny iny iny
	//end skips
	dp_skip2:
	//to the next
	dex
	cpx #00
	bne dp_next_pixel
	
rts

//snap hero to cell by heroX heroY
snapHero:
   ldx heroX
   lda #01 //second bit = sprite 0
   jsr calculateX
   stx $d000    // set x coordinate
                    
   ldy heroY //load y
   jsr calculateY
   sta $d001    // set y coordinate    
rts

//move hero sprite according to movedir
moveHero:

dec heroMoveCount
lda heroMoveDir

cmp #01
bne mh_not_1
sec
lda $d000
sbc #01
sta $d000
bcs mh_not_less_256
lda #$fe //sprite 0
and $d010//reset
sta $d010//bit
mh_not_less_256:
rts

mh_not_1:
cmp #02
bne mh_not_2
clc
lda $d000
adc #01
sta $d000
bcc mh_not_more_256
lda #01 //sprite 0
ora $d010//set
sta $d010//bit
mh_not_more_256:
rts

mh_not_2:
cmp #03
bne mh_not_3
inc $d001
rts
mh_not_3:
cmp #04
bne mh_not_4
dec $d001
rts
mh_not_4:

rts

//calculate x coord from cell
//in x - cell coord x
//in a - bit of $d010
//ret in x - coord
//in $d010 bit is setted or reset
calculateX:
  tay //transfer bit mask to Y
  inx//+1
  inx//+2
  txa //get x
  clc//clear cary flag
  asl //x2
  asl //x4
  asl //x8
  tax//save x coord
  
  bcc cx_low256
  tya//restore bit mask
  ora $d010//set
  sta $d010//bit
  rts
  cx_low256:
  tya //restore bit mask
  //invert
  eor #$ff
  //and
  and $d010//reset
  sta $d010//bit
rts

//calculate y coord from cell
//in y - y coord
//ret in y - new coord
calculateY:
 
 iny//+5
 iny//fix
 iny//for
 iny//sprite
 iny//yeah

 tya //get y
 clc//clear cary flag
 asl //x2
 asl //x4
 asl //x8
 tay//save y coord

rts

//init hero
init_hero:
       
			
			//calculate position with +7 +9 to fit game window      
			clc
			//border fix
			lda #05  //+2 for sprite fix
			adc heroX
			sta heroX
			
			clc
			//border fix
			lda #04 //+5 for sprite fix
			adc heroY
			sta heroY
                                  
        	jsr snapHero

           lda #$01
           ora $d015
           sta $d015    // Turn sprite 0 on
         
           //01 - white hero 01 skull 12-fantom 15-fantom
           lda #01
           sta $d027    // Make it ram color
                    
           //set frame according to x coord if >20 turn left if <20 turn right
           jsr heroSetStandRightAnimation
           ldx heroX
           cpx #20
           bpl ih_less_20
		   jsr heroSetStandLeftAnimation           
           ih_less_20:
           
           
           //init phantom
           lda heroX
           sta phantomX
           lda heroY
           sta phantomY
           
           //set up start position for phantom
           lda #00
		   stx $d002    // set x coordinate
           sta $d003    // set y coordinate

           lda #$02
           ora $d015
           sta $d015    // Turn sprite 1 on
         
           //01 - white hero 01 skull 12-fantom 15-fantom
           lda #01
           sta $d028    // Make it ram color
           
           lda #12+vBaseSprites
           sta phantomFrame
           //set frame
           sta $07f9    // set pointer: sprite data
           
           //reset movecount and movedir
           lda #00
           sta heroMoveCount
           sta heroMoveDir
           sta fireButtonUp
           sta heroState
           
        
rts

//set pixel
setPixel:
	
	inc collectCount
	
	pha				
	//save to table pixel
	ldy #0
	lda #1
	sta (pixelsPointer),y//enable it
	
	iny // kind temporary
	pla//restore byte
	pha//save back
	
	cmp #38 //is phantom 
	bne sp_not_phantom
	lda #01
	sta (pixelsPointer),y//save phantom kind = 1
	jmp sp_zzz
	sp_not_phantom:
	lda #00
	sta (pixelsPointer),y
	sp_zzz:
	
	
	
	iny //low byte drawing
	lda screenPointer
	sta (pixelsPointer),y

	iny //hi byte drawing
	lda screenPointer+1
	sta (pixelsPointer),y
	//save coords
	iny//y
	lda stackY
	clc
	adc #04
	sta (pixelsPointer),y
	iny //x
	lda stackX
	clc
	adc #05
	sta (pixelsPointer),y	
	//to the next pixel
	jsr incPixelsPointer
	pla
	
rts

setStar:

pha
	//enable	
	ldy #0
	lda #1
	sta (starsPointer),y//enable it
	
	iny //skip frame
		
	iny //low byte drawing
	lda screenPointer
	sta (starsPointer),y
		
	iny //hi byte drawing
	lda screenPointer+1
	sta (starsPointer),y
	
	//to the next pixel
	jsr incStarsPointer
	pla
	lda #00
	
rts

//==========add enemies to level sub=====
// enabled
// movedir
// movecount
// spriteMask
// x coord sprite address
// y coord sprite address
//spriteFrame address


addUpEnemy:
ldy #00//reset Y
//enable
lda #01
sta (enemiesPointer),y
//movedir
iny
lda #04//4 - up
sta (enemiesPointer),y
//movecount
iny
lda #00//zero move count
sta (enemiesPointer),y
//sprite number
iny
//get sprite mask by number
lda (enemiesPointer),y
jsr getSpriteMask
//enable sprite
ora $d015
sta $d015
//y cell coord
iny
lda stackY
//cell fix +4
clc
adc #04
sta (enemiesPointer),y
//x cell coord
iny
lda stackX
//cell fix +5
clc
adc #05
sta (enemiesPointer),y
jsr incEnemiesPointer
rts


addDownEnemy:
ldy #00//reset Y
//enable
lda #01
sta (enemiesPointer),y
//movedir
iny
lda #03//3 - down
sta (enemiesPointer),y
//movecount
iny
lda #00//zero move count
sta (enemiesPointer),y
//sprite number
iny
//get sprite mask by number
lda (enemiesPointer),y
jsr getSpriteMask
//enable sprite
ora $d015
sta $d015
//y cell coord
iny
lda stackY
//cell fix +4
clc
adc #04
sta (enemiesPointer),y
//x cell coord
iny
lda stackX
//cell fix +5
clc
adc #05
sta (enemiesPointer),y
jsr incEnemiesPointer
rts

addRightEnemy:

ldy #00//reset Y
//enable
lda #01
sta (enemiesPointer),y
//movedir
iny
lda #02//2 - right
sta (enemiesPointer),y
//movecount
iny
lda #00//zero move count
sta (enemiesPointer),y
//sprite number
iny
//get sprite mask by number
lda (enemiesPointer),y
jsr getSpriteMask
//enable sprite
ora $d015
sta $d015
//y cell coord
iny
lda stackY
//cell fix +4
clc
adc #04
sta (enemiesPointer),y
//x cell coord
iny
lda stackX
//cell fix +5
clc
adc #05
sta (enemiesPointer),y
jsr incEnemiesPointer
rts

addLeftEnemy:


ldy #00//reset Y
//enable
lda #01
sta (enemiesPointer),y
//movedir
iny
lda #01//2 - left
sta (enemiesPointer),y
//movecount
iny
lda #00//zero move count
sta (enemiesPointer),y
//sprite number
iny
//get sprite mask by number
lda (enemiesPointer),y
jsr getSpriteMask
//enable sprite
ora $d015
sta $d015
//y cell coord
iny
lda stackY
//cell fix +4
clc
adc #04
sta (enemiesPointer),y
//x cell coord
iny
lda stackX
//cell fix +5
clc
adc #05
sta (enemiesPointer),y
jsr incEnemiesPointer

rts

//=======================================

init_enemies:

//disable all enemies
lda #00//disabled
sta enemiesTable+6*0
sta enemiesTable+6*1
sta enemiesTable+6*2
sta enemiesTable+6*3
sta enemiesTable+6*4
sta enemiesTable+6*5

//disable all sprites
//sta $d015    // Turn off all sprites

//set ram colors 
   lda #01
   sta $d029    //sprite 2 e.t.c it's an enemies
   sta $d02A
   sta $d02B
   sta $d02C
   sta $d02D
   sta $d02E
   
//setup enemies frames tickers
lda #16+vBaseSprites
sta enemyRightFrame
lda #20+vBaseSprites
sta enemyLeftFrame
lda #24+vBaseSprites
sta enemyUpDownFrame
      
rts

//set color etc for dif worlds
setWorld:

	lda playLevel
	
	cmp #11
	bpl sw_not1

//set mulcitcolors we have 12 and 2
	lda #12
 	sta $d023
	lda #02
 	sta $d022
 	lda #52
 	sta restoreByte
 	
 	lda #4
 	sta tiles_colors+17
	rts
	
	sw_not1:
	cmp #21
	bpl sw_not2
 	 	
 	//world2
 	lda #03
 	sta $d022
 	lda #46
 	sta restoreByte
 	
 	lda #5
 	sta tiles_colors+17
 	rts
 	
 	sw_not2:
 	//world3
 	lda #04
 	sta $d022
 	lda #50
 	sta restoreByte
 	
 	lda #3
 	sta tiles_colors+17
 	
rts

//draw level on screen
init_level:

   jsr setWorld
   
   //load phantoms count
   ldx playLevel
   lda phantomsCountTable,x
   sta phantomsCount
   
   //set crack bridge frame to 0
   lda restoreByte
   sta crackBridgeFrame
   lda #00
   sta collectCount
   
   //
   jsr resetPixels
   //set screen,color,level,pixels pointers to start
   jsr initPointers 	
    //init enemies
   jsr init_enemies
   //draw level on screen
   jsr draw_level
   //re init pointers
   jsr initPointers
   
   
   
rts

//reset all pixels
resetPixels:
lda #00
sta pixelsTable
sta pixelsTable+6*1
sta pixelsTable+6*2
sta pixelsTable+6*3
sta pixelsTable+6*4
sta pixelsTable+6*5
sta pixelsTable+6*6
sta pixelsTable+6*7
sta pixelsTable+6*8
sta pixelsTable+6*9
sta pixelsTable+6*10
sta pixelsTable+6*11
sta pixelsTable+6*12
sta pixelsTable+6*13
sta pixelsTable+6*14
sta pixelsTable+6*15
rts

//draw level on screen
draw_level:
		
	

	ldy #00 //lines count
	sty phantomKind //reset phantom kind to 0
	
new_line_loop:
	//save lines count
	sty stackY
		
	ldx #00 //total tiles count in a line
		
one_line_loop:
	
	ldy #0 //reset y
	
	//save x
	stx stackX
	
	//get character (grab from level pointer)
	lda (levelPointer),y
	
	//save all
	sty stack2Y
	stx stack2X
		
	//is it enemys
	cmp #34
	bne dl_not_enemy_right
	jsr addRightEnemy
	lda restoreByte
	dl_not_enemy_right:
	
	
	cmp #35
	bne dl_not_enemy_left
	jsr addLeftEnemy	
	lda restoreByte
	dl_not_enemy_left:
	
	cmp #36
	bne dl_not_enemy_up
	jsr addUpEnemy	
	lda restoreByte
	dl_not_enemy_up:
	
	cmp #37
	bne dl_not_enemy_down
	jsr addDownEnemy	
	lda restoreByte
	dl_not_enemy_down:
	
	//is it pixel ?
	cmp #17 //17 - first frame of pixel
	bne dl_not_pixel
	jsr setPixel
dl_not_pixel:

	//phantom pixel
	cmp #38
	bne dl_not_phantom_pixel
	jsr setPixel
dl_not_phantom_pixel:

	//is it star
	cmp #21 // 21 - star frames
	bne dl_not_star
	jsr setStar
	
dl_not_star:

	//is it start point
	cmp #32
	bne dl_not_start_point
	//place a hero start point
	lda stackX
	sta heroX
	lda stackY
	sta heroY
	//not draw it
	lda restoreByte
	
dl_not_start_point:

	//vertical phantom switch
	cmp #33
	bne dl_not_vertical_switch
	lda #01
	sta phantomKind
	lda restoreByte
	dl_not_vertical_switch:
	
    //restore all
	
	ldx stack2X
	ldy stack2Y
	
	//put it to screen
	sta (screenPointer),y
	//get color
	tax //transfer to x
	lda tiles_colors,x //get tile RAM color to a
	//put it on screen
	sta (colorPointer),y
	
	//next one
	jsr stepPointers
	//restore x
	ldx stackX
	
	inx //dec x
	cpx #30 //end of line
    bne one_line_loop //new one
    
	//step pointer line down
	jsr stepPointersDown
	//restory y
	ldy stackY
	iny
	cpy #16//end of lines
	bne new_line_loop
	
rts

//step pointers
incPixelsPointer:

	lda pixelsPointer //load to a low byte from 251
	clc //clear carry flag
	adc #6 //add 6 to ac-r
	sta pixelsPointer //save low byte
	lda pixelsPointer+1 //load high byte
	adc #0  //add 0 with cary if cary set after prev adc that add hi byte
	sta pixelsPointer+1 //save high byte
rts

//step pointers
incStarsPointer:

	lda starsPointer //load to a low byte from 251
	clc //clear carry flag
	adc #4 //add 4 to ac-r
	sta starsPointer //save low byte
	lda starsPointer+1 //load high byte
	adc #0  //add 0 with cary if cary set after prev adc that add hi byte
	sta starsPointer+1 //save high byte
rts


//inc enemy pointer
incEnemiesPointer:
	lda enemiesPointer //load to a low byte from 251
	clc //clear carry flag
	adc #6 //add 6 bytes per enemy
	sta enemiesPointer //save low byte
	lda enemiesPointer+1 //load high byte
	adc #0  //add 0 with cary if cary set after prev adc that add hi byte
	sta enemiesPointer+1 //save high byte
rts

//step pointers
stepPointers:

//so level pointer
	lda levelPointer //load to a low byte from 251
	clc //clear carry flag
	adc #1 //add 30 to ac-r
	sta levelPointer //save low byte
	lda levelPointer+1 //load high byte
	adc #0  //add 0 with cary if cary set after prev adc that add hi byte
	sta levelPointer+1 //save high byte
//so color pointer	
	lda colorPointer //load to a low byte from 251
	clc //clear carry flag
	adc #1 //add 40 to ac-r
	sta colorPointer //save low byte
	lda colorPointer+1 //load high byte
	adc #0  //add 0 with cary if cary set after prev adc that add hi byte
	sta colorPointer+1 //save high byte
//so screen pointer	
	lda screenPointer //load to a low byte from 251
	clc //clear carry flag
	adc #1 //add 40 to ac-r
	sta screenPointer //save low byte
	lda screenPointer+1 //load high byte
	adc #0  //add 0 with cary if cary set after prev adc that add hi byte
	sta screenPointer+1 //save high byte
	
rts

stepPointersDown:

//so color pointer	
	lda colorPointer //load to a low byte from 251
	clc //clear carry flag
	adc #10 //add 40 to ac-r
	sta colorPointer //save low byte
	lda colorPointer+1 //load high byte
	adc #0  //add 0 with cary if cary set after prev adc that add hi byte
	sta colorPointer+1 //save high byte
//so screen pointer	
	lda screenPointer //load to a low byte from 251
	clc //clear carry flag
	adc #10 //add 40 to ac-r
	sta screenPointer //save low byte
	lda screenPointer+1 //load high byte
	adc #0  //add 0 with cary if cary set after prev adc that add hi byte
	sta screenPointer+1 //save high byte
	
rts

//
initEnemiesPointer:
//set enemies pointer
	lda #<enemiesTable //low byte
	sta enemiesPointer //save 
	lda #>enemiesTable //high byte
	sta enemiesPointer+1//save
rts

//set screen,color and level pointers
initPointers:

	jsr initEnemiesPointer

		
	lda playLevel
	asl //x2 since word get 2 bytes
	tay
	
	lda levels_table,y
	sta levelPointer
	iny
	lda levels_table,y
	sta levelPointer+1
	
	
//set level pointer to start of level
	//lda #<level //low byte level adress
	//sta levelPointer //save to level pointer
	//lda #>level //high byte level adress
	//sta levelPointer+1//save to level pointer
	
	
	
	//set screen pointer to start screen
	lda #<screenStart //low byte screen start
	sta screenPointer //save low byte
	lda #>screenStart //high byte screen start
	sta screenPointer+1 //hi byte save
	
	//set color pointer to start screen
	lda #<colorStart //low byte color start
	sta colorPointer //save low byte
	lda #>colorStart //high byte color start
	sta colorPointer+1 //hi byte save
	
	//set pixeltable pointer
	lda #<pixelsTable //low byte
	sta pixelsPointer //save
	lda #>pixelsTable //high byte
	sta pixelsPointer+1//save
	
	//set stars pointer
	lda #<starsTable //low byte
	sta starsPointer //save
	lda #>starsTable //high byte
	sta starsPointer+1//save
	
rts

//wait scanline to hit end of active game windows
wait_scanline:

jsr do_sounds
wsl_loop:
    //wait for raster after main screen	
    lda $d012    // load $d012 (curent raster line)
    cmp #205     // near the end of drawing area ??
    bne wsl_loop // if not, keep checking
    
rts


init_screen:

 sei //turn off interupts
 
//colors init
 lda #00 //zero to a
 sta $d020 //black border
 sta $d021 //black background
 
//clear screen 
 tax //transfer acc to X - quick ldx 0 :)
 lda #$00 //put 00 to a $20 - space ASCI code
 
clrloop:
 lda #00
 sta $0400,x //put value of acc in ($0400 + value in X reg)
 sta $0500,x
 sta $0600,x
 sta $0700,x
 lda #01
 sta $d800,x
 sta $d900,x
 sta $da00,x
 sta $db00,x
 
 dex         //dec x
 bne clrloop
 
 
 //enable multicolor mode
 lda #216
 sta 53270
 
 //point vic to new charset
 //flip 24 and 26
  lda #24
  sta $d018
  sta charsetFrame
 

  
rts

init:

	//init anim delay
	lda #vAnimDelay
	sta animDelay
	
	lda #vCharsetDelay
	sta charsetDelay
	
	//current pixels frame is 17
	lda #17
	sta pixelsFrame
	
	lda #vStartLevel
	sta playLevel
			
rts

//read joy port 2 and save buttons
read_joy:

djrr:    lda $dc00     // get input from port 2 only
djrrb:   ldy #0        // this routine reads and decodes the
        ldx #0        // joystick/firebutton input data in
        lsr           // the accumulator. this least significant
        bcs djr0      // 5 bits contain the switch closure
        dey           // information. if a switch is closed then it
djr0:    lsr           // produces a zero bit. if a switch is open then
        bcs djr1      // it produces a one bit. The joystick dir-
        iny           // ections are right, left, forward, backward
djr1:    lsr           // bit3=right, bit2=left, bit1=backward,
        bcs djr2      // bit0=forward and bit4=fire button.
        dex           // at rts time dx and dy contain 2's compliment
djr2:    lsr           // direction numbers i.e. $ff=-1, $00=0, $01=1.
        bcs djr3      // dx=1 (move right), dx=-1 (move left),
        inx           // dx=0 (no x change). dy=-1 (move up screen),
djr3:    lsr           // dy=0 (move down screen), dy=0 (no y change).
        stx dx        // the forward joystick position corresponds
        sty dy        // to move up the screen and the backward
                      // position to move down screen.
                      //
                      // at rts time the carry flag contains the fire
                      // button state. if c=1 then button not pressed.
                      // if c=0 then pressed.
rts

//put byte to cell
//in x- x,y-y
//a-byte
putByteToCell:

 pha
 jsr getScreenAddressByCell
 pla
 sta (screenPointer),y
 
rts

putColorToCell:

 pha
 jsr getColorAddressByCell
 pla
 sta (colorPointer),y
 
rts

//get byte from cell
//in x- x,y-y
//out a-byte
getByteFromCell:
jsr getScreenAddressByCell
lda (screenPointer),y
rts

//in x- x,y-y
//out: screen pointer points to screen address
getScreenAddressByCell:

	tya
	asl
	tay
	
	lda screenTable,y
	sta screenPointer
	iny
	lda screenTable,y
	sta screenPointer+1
	
	txa
	tay
	
rts

getColorAddressByCell:

	tya
	asl
	tay
	
	lda colorsTable,y
	sta colorPointer
	iny
	lda colorsTable,y
	sta colorPointer+1
	
	txa
	tay
	
rts

//sprites procedures
//in a - sprite num
//out in a - mask
getSpriteMask:
//save Y
sty tmpY
	tay
	lda table_spriteMask,y
//restoreY
ldy tmpY
rts

//in a -sprite num
//out in spritePointer - adress of X
// y -dead a -dead
getSpriteAddressX:

	asl //x2
	tay
	
	//low byte
	lda table_spriteX,y
	sta spritePointer //low byte
	//high byte
	iny
	lda table_spriteX,y
	sta spritePointer+1//hi byte
				
rts
getSpriteAddressY:

	asl //x2
	tay
	
	//low byte
	lda table_spriteY,y
	sta spritePointer //low byte
	//high byte
	iny
	lda table_spriteY,y
	sta spritePointer+1//hi byte
				
rts

getSpriteFrame:

	asl //x2
	tay
	
	//low byte
	lda table_spriteFrame,y
	sta spritePointer //low byte
	//high byte
	iny
	lda table_spriteFrame,y
	sta spritePointer+1//hi byte
				
rts

//x - x, y-y
//textPointer - point to text
draw_text:
pha
stx stackX
sty stackY
jsr getScreenAddressByCell
ldx stackX
ldy stackY
jsr getColorAddressByCell

ldy #$00         // init X register with $00
loop_text:  lda (textPointer),y  // read characters from line1 table of text...

			
            cmp #'#'         //check if it "#" - this is an end of string
            beq loop_text_end    // loop if we are not done yet
			
            cmp #' '
            beq text_skip_letter
            
            //numbers
            cmp #'0'
            bmi text_not_number
            sec
            sbc #21
            text_not_number:
            //for letters           
            clc
            adc #55 //add 55 to fit with tiles
            sta (screenPointer),y       
            pla
            sta (colorPointer),y
            pha
            text_skip_letter:
            
            iny
            jmp loop_text
            
loop_text_end:
pla
            
rts


draw_statusbar:

    lda #<t_status //low byte
	sta textPointer //save
	lda #>t_status //high byte
	sta textPointer+1//save
	
	ldy #22//y
	lda #01
	jsr draw_text
	
rts

drawTitle:

    lda #<t_gametitle //low byte
	sta textPointer //save
	lda #>t_gametitle //high byte
	sta textPointer+1//save
	
	ldy #02//y
	lda #03
	jsr draw_text
	
rts

drawPressFire:
    lda #<t_pressfire //low byte
	sta textPointer //save
	lda #>t_pressfire //high byte
	sta textPointer+1//save
	
	ldy #23//y
	lda #06
	jsr draw_text
rts

main_menu:

	
	jsr init_screen //init screen
	jsr wait_scanline
	
		
	lda #00
	sta playLevel
		
	jsr init_level //draw level on screen
	jsr init_hero //init hero
	
	jsr drawTitle
	jsr drawPressFire
	
	jsr heroSetSitAnimation
	
mm_loop:
	
	jsr wait_scanline
	jsr draw_anim_tiles 
	jsr do_animation
	jsr do_phantom
	jsr read_joy
	
		
	bcs mm_loop

		
	lda #vStartLevel
	sta playLevel
	jsr init_screen
	jsr disableStars
	
	lda #vMaxLives
	sta lives
		
	jmp restart	
rts


//disbale animated stars
disableStars:
lda #00
sta starsTable
sta starsTable+4
sta starsTable+4*2
sta starsTable+4*3
sta starsTable+4*4
sta starsTable+4*5
sta starsTable+4*6
sta starsTable+4*7

rts
// A border macro
.macro SetBorderColor(color) {
        lda #color
        sta $d020
}



//.import source "exomizer.asm"

           
//    14336 
.pc = $3800-64*1 "Sprites"
//sprites import
sprites: .import binary "gfx\sprites.bin"

//10000
.pc = $2800 "Alt charset"
tiles2: .import binary "gfx\tiles2.bin"
font2: .import binary "gfx\font.bin"
//8096
.pc =  $2000 "TIles&gfx&levelbuffer"
//tiles
tiles: .import binary "gfx\tiles.bin"
font: .import binary "gfx\font.bin"
//import RAM COLORS (multicolors shared for all tiles mc1-2 mc2-12) and also collision data (last 4 bits 0-pass 1-solid 2-ladder 3-water 4-pixel)
tiles_colors: .import binary "gfx\tiles_colors.bin"
//collision for tiles
tiles_collisions: .byte 0,1,2,3,1,0,0,5,1,1,0,0,3,1,1,1,1,4,4,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,2,1,1,0,2,0,0,0
//jumping pixels - max 16
pixelsTable:
//----enabled---kind----scr adr-----y-x--
.byte 0,        0 .word $0400 .byte 0,0
.byte 0,        0 .word $0401 .byte 0,0
.byte 0,        0 .word $0402 .byte 0,0
.byte 0,        0 .word $0403 .byte 0,0
.byte 0,        0 .word $0404 .byte 0,0
.byte 0,        0 .word $0405 .byte 0,0
.byte 0,        0 .word $0406 .byte 0,0
.byte 0,        0 .word $0407 .byte 0,0
.byte 0,        0 .word $0408 .byte 0,0
.byte 0,        0 .word $0409 .byte 0,0
.byte 0,        0 .word $040A .byte 0,0
.byte 0,        0 .word $040B .byte 0,0
.byte 0,        0 .word $040C .byte 0,0
.byte 0,        0 .word $040D .byte 0,0
.byte 0,        0 .word $040E .byte 0,0
.byte 0,        0 .word $040F .byte 0,0
//background animated stars - max 8
starsTable:
//--enabled---frame--drawing adr
.byte 0,      21    .word $0400
.byte 0,      23    .word $0401
.byte 0,      25    .word $0402
.byte 0,      27    .word $0403
.byte 0,      29    .word $0404
.byte 0,      31    .word $0405
.byte 0,      21    .word $0406
.byte 0,      23    .word $0407
//enemies table - max 6 enemies
enemiesTable:
//animFrames - global for all enemies
//based on movedir
//====enabled=movedir=====movecont=sprite_num========y=====x====
.byte 0,      0,          0,       2, 		        0,     0        
.byte 0,      0,          0,       3, 		        0,     0
.byte 0,      0,          0,       4,		        0,     0
.byte 0,      0,          0,       5, 		        0,     0
.byte 0,      0,          0,       6, 		        0,     0
.byte 0,      0,          0,       7,		        0,     0

//table for sprites
table_spriteX:
.word $d000,$d002,$d004,$d006,$d008,$d00a,$d00c,$d00e
table_spriteY:
.word $d001,$d003,$d005,$d007,$d009,$d00b,$d00d,$d00f
table_spriteFrame:
.word $07f8,$07f9,$07fa,$07fb,$07fc,$07fd,$07fe,$07ff
table_spriteMask:
.byte 1,2,4,8,16,32,64,128
//dead moving
dead_deltaY: .byte -1,-1,-1,-1,-1,0,0,0,0,1,1,1,1,1,0
dead_colors: .byte 1,  2, 1, 2, 1,2,1,2,1,2,1,2,1,2,0
//table of screen addresses
//use by get adr by X Y
screenTable:
.word 1024,1024+1*40,1024+2*40,1024+3*40,1024+4*40,1024+5*40,1024+6*40,1024+7*40,1024+8*40,1024+9*40,1024+10*40,1024+11*40,1024+12*40,1024+13*40,1024+14*40,1024+15*40,1024+16*40,1024+17*40,1024+18*40,1024+19*40,1024+19*40,1024+20*40,1024+21*40,1024+22*40,1024+23*40
colorsTable:
.word 55296,55296+1*40,55296+2*40,55296+3*40,55296+4*40,55296+5*40,55296+6*40,55296+7*40,55296+8*40,55296+9*40,55296+10*40,55296+11*40,55296+12*40,55296+13*40,55296+14*40,55296+15*40,55296+16*40,55296+17*40,55296+18*40,55296+19*40,55296+20*40,55296+21*40,55296+22*40,55296+23*40
phantomsCountTable: .byte 0,2,2,0,3,4,2,2,4,2,4,1,3,2,3,5,2,9,4,3,6,2,3,2,6,0,0
//texts 
t_gametitle: .text "            a l t e r   e g o#"
t_pressfire: .text "           press fire to start#"
t_status: .text "       lives:5         phantoms:4#"

.pc = 16384 "Levels Data & sounds"

//our unpacked level - place to unpack levels
//level: .import binary "levels\level21.bin"
levels_table: .word level0,level1,level2,level3,level4,level5,level6,level7,level8,level9,level10,level11,level12
			  .word level13,level14,level15,level16,level17,level18,level19,level20,level21,level22,level23,level24,level25,level26
level:
level0: .import binary "levels\level0.bin"
level1: .import binary "levels\level1.bin"
level2: .import binary "levels\level2.bin"
level3: .import binary "levels\level3.bin"
level4: .import binary "levels\level4.bin"
level5: .import binary "levels\level5.bin"
level6: .import binary "levels\level6.bin"
level7: .import binary "levels\level7.bin"
level8: .import binary "levels\level8.bin"
level9: .import binary "levels\level9.bin"
level10: .import binary "levels\level10.bin"
level11: .import binary "levels\level11.bin"
level12: .import binary "levels\level12.bin"
level13: .import binary "levels\level13.bin"
level14: .import binary "levels\level14.bin"
level15: .import binary "levels\level15.bin"
level16: .import binary "levels\level16.bin"
level17: .import binary "levels\level17.bin"
level18: .import binary "levels\level18.bin"
level19: .import binary "levels\level19.bin"
level20: .import binary "levels\level20.bin"
level21: .import binary "levels\level21.bin"
level22: .import binary "levels\level22.bin"
level23: .import binary "levels\level23.bin"
level24: .import binary "levels\level24.bin"
level25: .import binary "levels\level25.bin"
level26: .import binary "levels\level26.bin"

//=============SOUNDS=================
soundsTable: .word sNull,sComplete,sCollect,sDead,sTeleport,sHello,sSkullJump,sCrack
//sounds data
// lo freq hi-freq duration
sNull:
.byte -1,-1,-1
//complete level
sComplete:
.word 4000 .byte 10
.word 5000 .byte 6
.word 4000 .byte 10
.word 5000 .byte 8
.word 4000 .byte 100
.byte -1,-1,-1
//collect
sCollect:
.word 6000 .byte 5
//.word 6000 .byte 2
.word 4000 .byte 20
.byte -1,-1,-1
//dead
sDead:
.word 4000 .byte 5
.word 3100 .byte 5
.word 2100 .byte 5
.word 2000 .byte 25
.byte -1,-1,-1
sSkullJump:
//skull jump
.word 1000 .byte 5
.byte -1,-1,-1
sHello:
.word 5000 .byte 4
.word 5500 .byte 10
.word 5000 .byte 3
.word 5500 .byte 8
.word 6000 .byte 25
.byte -1,-1,-1
sTeleport:
.word 2100 .byte 4
.word 3500 .byte 20
.byte -1,-1,-1

sCrack:
.word 2100 .byte 10
//.word 1500 .byte 20
.byte -1,-1,-1

//play_sound
//a - which sound
playSound:

//set soundsPointer to sound

asl //x2 - address is word
tay

lda soundsTable,y
sta notePointer
iny
lda soundsTable,y
sta notePointer+1

//reset current note and duration
lda #00
sta nPointer
sta currentDuration

rts

//update and play all sound
do_sounds:
//check if current duration = 0 - get new note
lda currentDuration
bne continuePlaying
	
	lda #32
	sta SID+4
	
	//get new note
	ldy nPointer
	lda (notePointer),y//low fq
	
	cmp #-1//-1 - end playing
	bne continueNotEnd
	
	rts
	
	continueNotEnd:
	
	
	sta SID
	
	iny
	lda (notePointer),y//hi fq
	sta SID+1
	iny
	lda (notePointer),y//duration
	sta currentDuration
	lda #33
	sta SID+4
	iny
	sty nPointer
	
	
	
rts

continuePlaying:

//dec duration
dec currentDuration


rts

//clear all registers
initSID:

//clear current note duration
lda #00
sta currentDuration
sta nPointer

//point note pointer to null sound
lda #00
jsr playSound


//clear all 24 registers
ldx #24
lda #00
	cs_loop:
		sta SID,x
		dex
	bne cs_loop
	
//set Attack/Decay for voice 1 (a - 0, d-9) sustain and release = 0
lda #00
sta SID+6

lda #04
sta SID+5

//set volume
lda #15
sta SID+24

rts